package phuturewarez.craftableslime;

import java.io.File;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import phuturewarez.craftableslime.FMLEventHooks;
import phuturewarez.craftableslime.items.AddedItems;
import phuturewarez.craftableslime.lib.ConfigHandler;
import phuturewarez.craftableslime.lib.Reference;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.stats.Achievement;
import net.minecraft.stats.AchievementList;
import net.minecraft.util.RegistryNamespaced;
import cpw.mods.fml.common.FMLCommonHandler;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.Mod.EventHandler;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.registry.GameData;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.registry.LanguageRegistry;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.common.config.Configuration;
import net.minecraftforge.common.config.Property;
import net.minecraftforge.oredict.OreDictionary;
import net.minecraftforge.oredict.ShapelessOreRecipe;

@Mod(name = Reference.MOD_NAME, modid = Reference.MOD_ID, version = Reference.MOD_VER, guiFactory = "phuturewarez.craftableslime.lib.GUIFactory")
public class CraftableSlimeMain {

	// The instance of your mod that Forge uses.
    @Instance(value = Reference.MOD_ID)
    public static CraftableSlimeMain instance;
	public static Configuration config;
    public static final String modId = Reference.MOD_ID;
	public static Logger log = LogManager.getLogger("Craftable Slime");
    
    @EventHandler
    public void preInit(FMLPreInitializationEvent event) {
    	config = new Configuration(event.getSuggestedConfigurationFile());
    	ConfigHandler.syncConfig();
    	// If the built-in flour item and recipe are enabled...
    	if (ConfigHandler.useBuiltinFlourItem) {
            AddedItems.initItems();
            OreDictionary.registerOre("dustWheat", new ItemStack(AddedItems.dustWheat));
            GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.dustWheat), new Object[] {Items.wheat});
    	}
        // If flour is required...
        if (ConfigHandler.useFlourRecipe) {
            GameRegistry.addRecipe(new ShapelessOreRecipe(new ItemStack(Items.slime_ball, ConfigHandler.slimeballCraftCount), new Object[] {
            	"dustWheat", Items.water_bucket, Items.sugar, "dyeLime"
            }));        
        } else {
            GameRegistry.addRecipe(new ShapelessOreRecipe(new ItemStack(Items.slime_ball, ConfigHandler.slimeballCraftCount), new Object[] {
            	Items.water_bucket, Items.sugar, Items.sugar, "dyeLime"
            }));        
        }
    }
       
    @EventHandler
    public void load(FMLInitializationEvent event) {
        FMLCommonHandler.instance().bus().register(new FMLEventHooks());
    }
       
    @EventHandler
    public void postInit(FMLPostInitializationEvent event) {
    }
}